/* Copyright 1990 by Christopher A. Wichura.
   See file GIFMachine.doc for full description of rights.
*/

#include "GIFMachine.h"

UWORD TotalColours;
UWORD MasterColourTable[MAXCOLOURS];

UWORD AddColour(UBYTE *buf)
{
	register UWORD colour;
	register UWORD index;

	colour = (UWORD)(CVRTGIF(0) << 8 | CVRTGIF(1) << 4 | CVRTGIF(2));

	for (index = 0; index < TotalColours; index++) {
		if (colour == MasterColourTable[index])
			return index;
	}

	/* note that we don't check to see if the list is full.  this is
	   because we can't possibly have more than max colours because
	   16 * 16 * 16 is MAXCOLOURS and thus we will match somewhere in
	   the table when it is full.  Not to hot of en explanation, eh? */

	MasterColourTable[TotalColours] = colour;
	return TotalColours++;	
}
